cmhdbfb程序支持三种功能

#### 功能一：load 

简介：加载长安链filedb中的写集到bloom过滤器中

参数

- -c, --config //指定chainmaker.yaml文件

- -r, --fpr  //指定bloom过滤器的误报率，默认0.01

- -h, --help     //帮助

- -n, --items  //指定bloom过滤器的预定义容量，如业务大概支撑10000个key，则配置>=10000，默认100000000

- -d, --workdir //指定程序执行的工作路径，因为chainmaker.yaml中的路径配置的都是相对路径，为了能正确找到相关相对路径文件，需要配置工作路径

- -t, --thread //指定开启加载数据的线程数，默认为1

- -w, --workperthread //指定每个线程一轮工作的工作负载，默认10000个区块。

  如开启5个线程，每个线程工作负载为10000，则一轮工作相当于加载50000个区块的数据到布隆过滤器，如果总区块数为100万的话，需要做20个轮次的工作才能加载完所有数据，这种方式是为了避免一个轮次的工作负载分配过多的情况下，中途发生错误时导致过多的工作浪费。



\```

├── bin

├── config

├── data

├── lib

└── log

\```

按照长安链的路径和启动方式，我们的相对路径都是相对于bin路径

如：节点根路径为 /data/go/src/chainmaker.org/chainmaker-go/build/release/chainmaker-v2.3.3-wx-org1.chainmaker.org/

则启动方式如下：

```shell
./cmhdbfb load -c /data/go/src/chainmaker.org/chainmaker-go/build/release/chainmaker-v2.3.3-wx-org1.chainmaker.org/config/wx-org1.chainmaker.org/chainmaker.yml -n 100000 -r 0.01 -w /data/go/src/chainmaker.org/chainmaker-go/build/release/chainmaker-v2.3.3-wx-org1.chainmaker.org/bin -t 5
```



#### 功能二：verify

验证key是否存在

参数：

-f, --file 布隆过滤器加载的数据文件路径

使用实例

```shell
./cmhdbfb verify -f ./chain1
```



#### 功能三: history

读取historydb的数据，并输出，输出格式为{contractName} {key}

参数

-p, --db_path history数据库路径

实例

```shell
./cmhdbfb history -p /data/go/src/chainmaker.org/chainmaker-go/build/release/chainmaker-v2.3.3-wx-org1.chainmaker.org/data/wx-org1.chainmaker.org/history/chain1/store_history 
```